package ru.landgrafhomyak.db.skeleton1.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectOperations
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.table.Table
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow


public interface CreateModuleScope<mUE : Any, RK : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("rootNs")
	public val rootNs: Namespace<mUE, RK>

	public fun <tUE : Any> createTable(
		lifeTime: Table.LifeTime = Table.LifeTime.DATABASE_SCOPE,
		namespace: Namespace<mUE, RK> = this.rootNs,
		name: String, initializer: Table.Constructor<tUE, RK>
	): Table<tUE, mUE, RK>

	public fun <oUE : Any?> moduleScopedObject(namespace: Namespace<mUE, RK> = this.rootNs, name: String, metadata: ObjectOperations.ImplementationsProvider<oUE>): ModuleScopedObject<oUE, mUE, RK>

	public fun <mUE : Any> substituteModule(rootNs: Namespace<mUE, RK>, template: Module.Template<mUE>): Module<mUE, RK>

	public fun namespace(parent: Namespace<mUE, RK>, name: String): Namespace<mUE, RK>

	public fun addStatement(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)
	public fun addStatement(stmt: _Statement.Void2Void<*, RK>)

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, RK, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: _Statement.Params2Void<sUE, RK>): InputRow._Scope<sUE, RK, Unit>
}