package ru.landgrafhomyak.db.skeleton1.api.module

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow
import ru.landgrafhomyak.db.skeleton1.api.table.Table


public interface UpgradeModuleScope<nmUE : Any, omUE : Any, RK : Any> : CreateModuleScope<nmUE, RK> {
	public fun <tUE : Any> keepTable(table: Table<tUE, omUE, RK>): Table<tUE, nmUE, RK>

	public fun <tUE : Any> keepAndRenameTable(table: Table<tUE, omUE, RK>, newName: String): Table<tUE, nmUE, RK>
	public fun <tUE : Any> keepAndRenameTable(table: Table<tUE, omUE, RK>, newNamespace: Namespace<nmUE, RK>): Table<tUE, nmUE, RK>
	public fun <tUE : Any> keepAndRenameTable(table: Table<tUE, omUE, RK>, newNamespace: Namespace<nmUE, RK>, newName: String): Table<tUE, nmUE, RK>

	public fun <ntUE : Any, otUE : Any> upgradeTable(oldTable: Table<otUE, omUE, RK>, upgrade: Table.Upgrade<ntUE, otUE, RK>): Table<ntUE, nmUE, RK>
	public fun <ntUE : Any, otUE : Any> upgradeAndRenameTable(
		table: Table<otUE, omUE, RK>,
		newName: String,
		upgrade: Table.Upgrade<ntUE, otUE, RK>
	): Table<ntUE, nmUE, RK>

	public fun <ntUE : Any, otUE : Any> upgradeAndRenameTable(
		table: Table<otUE, omUE, RK>,
		newNamespace: Namespace<nmUE, RK>,
		upgrade: Table.Upgrade<ntUE, otUE, RK>
	): Table<ntUE, nmUE, RK>

	public fun <ntUE : Any, otUE : Any> upgradeAndRenameTable(
		table: Table<otUE, omUE, RK>,
		newNamespace: Namespace<nmUE, RK>,
		upgrade: Table.Upgrade<ntUE, otUE, RK>,
		newName: String
	): Table<ntUE, nmUE, RK>

	public fun deleteTable(table: Table<*, omUE, RK>)

	public fun <tUE : Any> deleteTableAfterModuleUpgrade(table: Table<tUE, omUE, RK>): Table<tUE, nmUE, RK>

	public fun exportTable(table: Table<*, omUE, RK>)

	public fun <tUE : Any> importTable(
		namespace: Namespace<nmUE, RK> = this.rootNs, name: String,
		table: Table<tUE, *, RK>
	): Table<tUE, nmUE, RK>

	public fun <ntUE : Any, otUE : Any> importAndUpgradeTable(
		namespace: Namespace<nmUE, RK> = this.rootNs, name: String,
		table: Table<otUE, *, RK>,
		upgrade: Table.Upgrade<ntUE, otUE, RK>
	): Table<ntUE, nmUE, RK>

	public fun <smUE : Any> keepModule(module: Module<smUE, RK>): Module<smUE, RK>
	public fun <smUE : Any> keepAndMoveModule(oldModule: Module<smUE, RK>, newNs: Namespace<nmUE, RK>): Module<smUE, RK>

	public fun <smUE : Any> upgradeModule(oldModule: Module<*, RK>, template: Module.Template<smUE>): Module<smUE, RK>
	public fun <smUE : Any> upgradeAndMoveModule(oldModule: Module<*, RK>, newNs: Namespace<nmUE, RK>, template: Module.Template<smUE>): Module<smUE, RK>

	public fun removeModule(oldModule: Module<*, RK>)
	public fun <smUE : Any> removeModuleAfterUpgrade(oldModule: Module<smUE, RK>): Module<smUE, RK>


	public fun addStatementAfterUpgrade(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)
	public fun addStatementAfterUpgrade(stmt: _Statement.Void2Void<*, RK>)

	@LowLevelApi
	public fun <sUE : Any> _addStatementAfterUpgrade(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, RK, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatementAfterUpgrade(stmt: _Statement.Params2Void<sUE, RK>): InputRow._Scope<sUE, RK, Unit>
}