package ru.landgrafhomyak.db.skeleton1.api.runtime

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.statement.OutputColumn
import ru.landgrafhomyak.db.skeleton1.api.table.Column

public interface OutputRow<qUE : Any, RK : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: qUE

	public operator fun <RuntimeType> get(c: OutputColumn<RuntimeType, qUE, RK>): RuntimeType

	public operator fun get(c: OutputColumn<Byte, qUE, RK>): Byte = this.get<Byte>(c)
	public operator fun get(c: OutputColumn<UByte, qUE, RK>): UByte = this.get<UByte>(c)
	public operator fun get(c: OutputColumn<Short, qUE, RK>): Short = this.get<Short>(c)
	public operator fun get(c: OutputColumn<UShort, qUE, RK>): UShort = this.get<UShort>(c)
	public operator fun get(c: OutputColumn<Int, qUE, RK>): Int = this.get<Int>(c)
	public operator fun get(c: OutputColumn<UInt, qUE, RK>): UInt = this.get<UInt>(c)
	public operator fun get(c: OutputColumn<Long, qUE, RK>): Long = this.get<Long>(c)
	public operator fun get(c: OutputColumn<ULong, qUE, RK>): ULong = this.get<ULong>(c)
	public operator fun get(c: OutputColumn<Char, qUE, RK>): Char = this.get<Char>(c)
	public operator fun get(c: OutputColumn<Boolean, qUE, RK>): Boolean = this.get<Boolean>(c)

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Scope<qUE : Any, RK : Any, out Next> : OutputRow<qUE, RK> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()
	}

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<qUE : Any, RK : Any, out Next> : _Scope<qUE, RK, Next>, OutputRow<qUE, RK> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _next(): Boolean

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _abort()

		@Suppress("FunctionName")
		@LowLevelApi
		public override suspend fun _finish(): Next
	}
}