package ru.landgrafhomyak.db.skeleton1.api.statement

import ru.landgrafhomyak.db.skeleton1.api.DriverType

public interface RawStatement<qUE : Any?, RUNTIME_KEY : Any> : _Statement<qUE, RUNTIME_KEY> {
	public override val uExt: qUE

	public interface Void2Void<qUE : Any?, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Void2Void<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any?>

		public interface ImplementationsProvider<USER_EXTENSION : Any?> {
			public fun provideStatementImplementations_void2void(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any?> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Void2Row<qUE : Any, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Void2Row<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2row(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Void2RowOrNull<qUE : Any, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Void2RowOrNull<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2rowOrNull(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}

	}

	public interface Void2Table<qUE : Any, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Void2Table<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_void2table(selector: Selector<USER_EXTENSION>)

			public interface Selector<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Void<qUE : Any, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Params2Void<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2void(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Row<qUE : Any, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Params2Row<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2row(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2RowOrNull<qUE : Any, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Params2RowOrNull<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2rowOrNull(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, *, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}

	public interface Params2Table<qUE : Any, RUNTIME_KEY : Any> : RawStatement<qUE, RUNTIME_KEY>, _Statement.Params2Table<qUE, RUNTIME_KEY> {
		override val uExt: qUE

		public interface Constructor<@Suppress("unused") qUE : Any>

		public interface ImplementationsProvider<USER_EXTENSION : Any> {
			public fun provideStatementImplementations_params2table(scope: Scope<USER_EXTENSION>)

			public interface Scope<USER_EXTENSION : Any> {
				@Suppress("ERROR_SUPPRESSION", "BOUNDS_NOT_ALLOWED_IF_BOUNDED_BY_TYPE_PARAMETER", "INCONSISTENT_TYPE_PARAMETER_BOUNDS")
				public fun <STATEMENT_CONSTRUCTOR, STATEMENT_CONSTRUCTOR_UNBOUND> addImplementation(
					driverType: DriverType<*, *, *, *, *, *, *, *, STATEMENT_CONSTRUCTOR_UNBOUND, *>,
					constructor: STATEMENT_CONSTRUCTOR
				) where STATEMENT_CONSTRUCTOR_UNBOUND : Constructor<*>,
						STATEMENT_CONSTRUCTOR : Constructor<USER_EXTENSION>,
						STATEMENT_CONSTRUCTOR : STATEMENT_CONSTRUCTOR_UNBOUND
			}
		}
	}
}