package ru.landgrafhomyak.db.skeleton1.api.table

import ru.landgrafhomyak.db.skeleton1.api.LowLevelApi
import ru.landgrafhomyak.db.skeleton1.api.ObjectOperations
import ru.landgrafhomyak.db.skeleton1.api.statement.RawStatement
import ru.landgrafhomyak.db.skeleton1.api.statement._Statement
import ru.landgrafhomyak.db.skeleton1.api.runtime.InputRow

public interface TableUpgradeScope<tnUE : Any, toUE : Any, RK : Any> : TableConstructorScope<tnUE, RK> {
	public fun <RT> keepColumn(c: Column<RT, toUE, RK>): Column<RT, tnUE, RK>
	public fun <RT> renameColumn(c: Column<RT, toUE, RK>, newName: String): Column<RT, tnUE, RK>
	public fun removeColumn(c: Column<*, toUE, RK>)
	public fun <RT> removeColumnAfterUpgrade(c: Column<RT, toUE, RK>): Column<RT, tnUE, RK>

	public fun <RT> keepColumnWithBoundType(c: Column<RT, toUE, RK>): Column<RT, tnUE, RK>
	public fun <RT> unbindAndKeepColumnWithBoundType(c: Column<RT, toUE, RK>): Column<RT, tnUE, RK>
	public fun <RT> renameColumnWithBoundType(c: Column<RT, toUE, RK>, newName: String): Column<RT, tnUE, RK>
	public fun <RT> unbindAndRenameColumnWithBoundType(c: Column<RT, toUE, RK>, newName: String): Column<RT, tnUE, RK>
	public fun removeColumnWithBoundType(c: Column<*, toUE, RK>)
	public fun <RT> removeColumnWithBoundTypeAfterUpgrade(c: Column<RT, toUE, RK>): Column<RT, tnUE, RK>

	public fun <oUE : Any?> keepTableScopedObject(obj: TableScopedObject<oUE, toUE, RK>): TableScopedObject<oUE, tnUE, RK>
	public fun <oUE : Any?> renameTableScopedObject(obj: TableScopedObject<oUE, toUE, RK>, newName: String): TableScopedObject<oUE, tnUE, RK>
	public fun <oUE : Any?> removeTableScopedObject(obj: TableScopedObject<oUE, toUE, RK>): TableScopedObject<oUE, tnUE, RK>


	public fun addAlterStatementAfterUpgrade(stmt: _Statement.Void2Void<*, RK>)
	public fun addAlterStatementAfterUpgrade(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatementAfterUpgrade(stmt: _Statement.Params2Void<sUE, RK>): InputRow._Scope<sUE, RK, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addAlterStatementAfterUpgrade(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, RK, Unit>
}